package com.cash.ws.controlador;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import java.util.function.Supplier;

import javax.sql.RowSet;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.ResponseBody;


import com.cash.ws.repositorio.AlergiaRepositorio;
import com.cash.ws.repositorio.AlergiaXPacienteRepositorio;
import com.cash.ws.repositorio.PacienteRepositorio;
import com.cash.ws.exception.ResourceNotFoundException;
import com.cash.ws.modelo.Alergia;
import com.cash.ws.modelo.Alergia_x_paciente;
//import com.cash.ws.modelo.Alergia_x_paciente;
import com.cash.ws.modelo.Paciente;

@Controller // This means that this class is a Controller
@RequestMapping(path = "/demo/v1")
public class MainController {

	@Autowired // This means to get the bean called userRepository
	// Which is auto-generated by Spring, we will use it to handle the data
	private PacienteRepositorio pacienteRepositorio;
	
	@Autowired // This means to get the bean called userRepository
	// Which is auto-generated by Spring, we will use it to handle the data
	private AlergiaRepositorio alergiaRepositorio;
	
	@Autowired // This means to get the bean called userRepository
	// Which is auto-generated by Spring, we will use it to handle the data
	private AlergiaXPacienteRepositorio alergiaxpacienterepositorio;
	
	
	@GetMapping(path="/accounts/{id}/record")
	//public @ResponseBody Iterable<Alergia> getAllAlergias() {
	public @ResponseBody Map<String,Map<String,String>>  getAllPacientes(@PathVariable Integer id) {
		// This returns a JSON or XML with the users
		//return alergiaRepositorio.findAll();
		Map<String,String> payload= new LinkedHashMap<String, String>();
		Map<String,String> alergiaRow=new LinkedHashMap<String, String>();
		Map<String,Map<String,String>> alergias = new LinkedHashMap<String, Map<String,String>>();
		Map<String,String> response= new LinkedHashMap<String, String>();
		Map<String,Map<String,String>> result = new LinkedHashMap<String, Map<String,String>>();		
		
		Paciente paciente=pacienteRepositorio.findById(id).get();
		
		Alergia alergia;
		Iterable<Alergia_x_paciente> alergiaPaciente = alergiaxpacienterepositorio.findAll();
		if(!Objects.isNull(paciente)) {
		Integer i=1;
		for(Alergia_x_paciente fila: alergiaxpacienterepositorio.findAll()) {
			if(id==fila.getPaciente_id()) {
				alergia = alergiaRepositorio.findById(fila.getAlergia_id()).get();
				alergiaRow.put("nombre"+i, alergia.getAlergia_nombre());
				alergiaRow.put("fecha_alta"+i, fila.getFecha_alta().toString());
				alergiaRow.put("medicamento"+i, fila.getMedicamento());
				i++;
			}
		}
		
		
		response.put("codigo", "200");
		response.put("mensaje", "Petición completada");
		payload.put("no_expediente",paciente.getPaciente_no_expediente().toString());
		payload.put("fecha_ultima_consulta", paciente.getPaciente_fecha_ultima_consulta().toString());
		payload.put("tipo_sangre", paciente.getPaciente_tipo_sangre());
		
		
		result.put("response", response);
		result.put("payload",payload );
		result.put("alergias", alergiaRow);
		}
		else {
			response.put("codigo", "400");
			response.put("mensaje", "El id de usuario no existe");
			result.put("response", response);
		}
		return result;
	}
	
}
